! Description: Include file that contains ice microphyscial model for GOES-15 imager sensor

select case(habit_idx)
   case(1)  !-- ice clouds modeled as droxtals (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.83715
        B_BETA_11um_67um_FIT_ICE =    0.16581
        A_BETA_11um_85um_FIT_ICE =    1.24554
        B_BETA_11um_85um_FIT_ICE =   -0.23654
        A_BETA_11um_133um_FIT_ICE =    0.01046
        B_BETA_11um_133um_FIT_ICE =    0.99352
        A_Re_Beta_FIT_ICE =  -12.51550
        B_Re_Beta_FIT_ICE =   26.39763
        C_Re_Beta_FIT_ICE =  -17.35321
        D_Re_Beta_FIT_ICE =    3.83872
        A_Qe_065um_FIT_ICE =    2.36538
        B_Qe_065um_FIT_ICE =   -0.33741
        C_Qe_065um_FIT_ICE =    0.08144
        A_Qe_11um_FIT_ICE =   -0.62848
        B_Qe_11um_FIT_ICE =    3.10427
        C_Qe_11um_FIT_ICE =   -0.88425
        A_wo_11um_FIT_ICE =   -0.08441
        B_wo_11um_FIT_ICE =    0.68337
        C_wo_11um_FIT_ICE =   -0.19256
        A_g_11um_FIT_ICE =    0.34749
        B_g_11um_FIT_ICE =    0.77421
        C_g_11um_FIT_ICE =   -0.23216

   case(2)  !-- ice clouds modeled as solid_bullet_rosettes (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.77720
        B_BETA_11um_67um_FIT_ICE =    0.22868
        A_BETA_11um_85um_FIT_ICE =    1.34023
        B_BETA_11um_85um_FIT_ICE =   -0.33627
        A_BETA_11um_133um_FIT_ICE =    0.03083
        B_BETA_11um_133um_FIT_ICE =    0.97301
        A_Re_Beta_FIT_ICE =  -10.40352
        B_Re_Beta_FIT_ICE =   24.91279
        C_Re_Beta_FIT_ICE =  -19.26992
        D_Re_Beta_FIT_ICE =    5.24110
        A_Qe_065um_FIT_ICE =    2.22067
        B_Qe_065um_FIT_ICE =   -0.23789
        C_Qe_065um_FIT_ICE =    0.06347
        A_Qe_11um_FIT_ICE =   -0.49288
        B_Qe_11um_FIT_ICE =    2.72023
        C_Qe_11um_FIT_ICE =   -0.73629
        A_wo_11um_FIT_ICE =   -0.00889
        B_wo_11um_FIT_ICE =    0.62291
        C_wo_11um_FIT_ICE =   -0.17737
        A_g_11um_FIT_ICE =    0.60478
        B_g_11um_FIT_ICE =    0.44504
        C_g_11um_FIT_ICE =   -0.12888 

   case(3)  !-- ice clouds modeled as hollow_bullet_rosettes (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.87909
        B_BETA_11um_67um_FIT_ICE =    0.12308
        A_BETA_11um_85um_FIT_ICE =    1.28885
        B_BETA_11um_85um_FIT_ICE =   -0.31244
        A_BETA_11um_133um_FIT_ICE =    0.00858
        B_BETA_11um_133um_FIT_ICE =    0.99389
        A_Re_Beta_FIT_ICE =   -9.72803
        B_Re_Beta_FIT_ICE =   21.90640
        C_Re_Beta_FIT_ICE =  -15.72167
        D_Re_Beta_FIT_ICE =    3.97868
        A_Qe_065um_FIT_ICE =    2.22436
        B_Qe_065um_FIT_ICE =   -0.21821
        C_Qe_065um_FIT_ICE =    0.05318
        A_Qe_11um_FIT_ICE =   -0.23189
        B_Qe_11um_FIT_ICE =    2.13433
        C_Qe_11um_FIT_ICE =   -0.52477
        A_wo_11um_FIT_ICE =    0.06011
        B_wo_11um_FIT_ICE =    0.51266
        C_wo_11um_FIT_ICE =   -0.14081
        A_g_11um_FIT_ICE =    0.72460
        B_g_11um_FIT_ICE =    0.29918
        C_g_11um_FIT_ICE =   -0.08466

   case(4)  !-- ice clouds modeled as solid_columns (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.85589
        B_BETA_11um_67um_FIT_ICE =    0.14732
        A_BETA_11um_85um_FIT_ICE =    1.24928
        B_BETA_11um_85um_FIT_ICE =   -0.24376
        A_BETA_11um_133um_FIT_ICE =    0.00961
        B_BETA_11um_133um_FIT_ICE =    0.99439
        A_Re_Beta_FIT_ICE =   -9.17689
        B_Re_Beta_FIT_ICE =   19.52922
        C_Re_Beta_FIT_ICE =  -12.81964
        D_Re_Beta_FIT_ICE =    2.88813
        A_Qe_065um_FIT_ICE =    2.29956
        B_Qe_065um_FIT_ICE =   -0.28841
        C_Qe_065um_FIT_ICE =    0.07042
        A_Qe_11um_FIT_ICE =   -0.51578
        B_Qe_11um_FIT_ICE =    2.80113
        C_Qe_11um_FIT_ICE =   -0.77395
        A_wo_11um_FIT_ICE =   -0.06694
        B_wo_11um_FIT_ICE =    0.67673
        C_wo_11um_FIT_ICE =   -0.19075
        A_g_11um_FIT_ICE =    0.41872
        B_g_11um_FIT_ICE =    0.68250
        C_g_11um_FIT_ICE =   -0.20467

   case(5)  !-- ice clouds modeled as hollow_columns (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.86373
        B_BETA_11um_67um_FIT_ICE =    0.14306
        A_BETA_11um_85um_FIT_ICE =    1.23889
        B_BETA_11um_85um_FIT_ICE =   -0.24031
        A_BETA_11um_133um_FIT_ICE =    0.00706
        B_BETA_11um_133um_FIT_ICE =    0.99615
        A_Re_Beta_FIT_ICE =   -8.66314
        B_Re_Beta_FIT_ICE =   17.98910
        C_Re_Beta_FIT_ICE =  -11.52575
        D_Re_Beta_FIT_ICE =    2.57872
        A_Qe_065um_FIT_ICE =    2.28877
        B_Qe_065um_FIT_ICE =   -0.27485
        C_Qe_065um_FIT_ICE =    0.06627
        A_Qe_11um_FIT_ICE =   -0.38066
        B_Qe_11um_FIT_ICE =    2.44419
        C_Qe_11um_FIT_ICE =   -0.64467
        A_wo_11um_FIT_ICE =   -0.02395
        B_wo_11um_FIT_ICE =    0.62675
        C_wo_11um_FIT_ICE =   -0.17697
        A_g_11um_FIT_ICE =    0.52490
        B_g_11um_FIT_ICE =    0.53943
        C_g_11um_FIT_ICE =   -0.15607

   case(6)  !-- ice clouds modeled as plates (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.84447
        B_BETA_11um_67um_FIT_ICE =    0.15541
        A_BETA_11um_85um_FIT_ICE =    1.16622
        B_BETA_11um_85um_FIT_ICE =   -0.19686
        A_BETA_11um_133um_FIT_ICE =    0.00719
        B_BETA_11um_133um_FIT_ICE =    0.99571
        A_Re_Beta_FIT_ICE =   -8.08695
        B_Re_Beta_FIT_ICE =   17.32739
        C_Re_Beta_FIT_ICE =  -11.31246
        D_Re_Beta_FIT_ICE =    2.55514
        A_Qe_065um_FIT_ICE =    2.20118
        B_Qe_065um_FIT_ICE =   -0.20101
        C_Qe_065um_FIT_ICE =    0.04899
        A_Qe_11um_FIT_ICE =   -0.44794
        B_Qe_11um_FIT_ICE =    2.69058
        C_Qe_11um_FIT_ICE =   -0.72956
        A_wo_11um_FIT_ICE =   -0.07897
        B_wo_11um_FIT_ICE =    0.72951
        C_wo_11um_FIT_ICE =   -0.21107
        A_g_11um_FIT_ICE =    0.46268
        B_g_11um_FIT_ICE =    0.62796
        C_g_11um_FIT_ICE =   -0.18617

   case(7)  !-- ice clouds modeled as aggregate_columns (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.93009
        B_BETA_11um_67um_FIT_ICE =    0.09617
        A_BETA_11um_85um_FIT_ICE =    1.35805
        B_BETA_11um_85um_FIT_ICE =   -0.32885
        A_BETA_11um_133um_FIT_ICE =    0.01034
        B_BETA_11um_133um_FIT_ICE =    0.99228
        A_Re_Beta_FIT_ICE =  -11.82807
        B_Re_Beta_FIT_ICE =   25.94673
        C_Re_Beta_FIT_ICE =  -18.09381
        D_Re_Beta_FIT_ICE =    4.36845
        A_Qe_065um_FIT_ICE =    2.22080
        B_Qe_065um_FIT_ICE =   -0.20400
        C_Qe_065um_FIT_ICE =    0.04844
        A_Qe_11um_FIT_ICE =   -0.35149
        B_Qe_11um_FIT_ICE =    2.42003
        C_Qe_11um_FIT_ICE =   -0.62767
        A_wo_11um_FIT_ICE =    0.00021
        B_wo_11um_FIT_ICE =    0.59942
        C_wo_11um_FIT_ICE =   -0.16946
        A_g_11um_FIT_ICE =    0.64039
        B_g_11um_FIT_ICE =    0.38072
        C_g_11um_FIT_ICE =   -0.10403

   case(8)  !-- ice clouds modeled as small_aggregate_plates (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.91832
        B_BETA_11um_67um_FIT_ICE =    0.08354
        A_BETA_11um_85um_FIT_ICE =    1.34189
        B_BETA_11um_85um_FIT_ICE =   -0.34937
        A_BETA_11um_133um_FIT_ICE =    0.01150
        B_BETA_11um_133um_FIT_ICE =    0.99165
        A_Re_Beta_FIT_ICE =  -10.51418
        B_Re_Beta_FIT_ICE =   23.25653
        C_Re_Beta_FIT_ICE =  -16.36464
        D_Re_Beta_FIT_ICE =    4.01544
        A_Qe_065um_FIT_ICE =    2.18729
        B_Qe_065um_FIT_ICE =   -0.16183
        C_Qe_065um_FIT_ICE =    0.03556
        A_Qe_11um_FIT_ICE =   -0.40243
        B_Qe_11um_FIT_ICE =    2.54256
        C_Qe_11um_FIT_ICE =   -0.66564
        A_wo_11um_FIT_ICE =    0.00650
        B_wo_11um_FIT_ICE =    0.57238
        C_wo_11um_FIT_ICE =   -0.15736
        A_g_11um_FIT_ICE =    0.63022
        B_g_11um_FIT_ICE =    0.41623
        C_g_11um_FIT_ICE =   -0.11970

   case(9)  !-- ice clouds modeled as large_aggregate_plates (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.93468
        B_BETA_11um_67um_FIT_ICE =    0.05465
        A_BETA_11um_85um_FIT_ICE =    1.32377
        B_BETA_11um_85um_FIT_ICE =   -0.36541
        A_BETA_11um_133um_FIT_ICE =    0.01074
        B_BETA_11um_133um_FIT_ICE =    0.99145
        A_Re_Beta_FIT_ICE =  -17.56944
        B_Re_Beta_FIT_ICE =   40.04734
        C_Re_Beta_FIT_ICE =  -29.48660
        D_Re_Beta_FIT_ICE =    7.38829
        A_Qe_065um_FIT_ICE =    2.09680
        B_Qe_065um_FIT_ICE =   -0.06041
        C_Qe_065um_FIT_ICE =    0.00681
        A_Qe_11um_FIT_ICE =   -0.46234
        B_Qe_11um_FIT_ICE =    2.54644
        C_Qe_11um_FIT_ICE =   -0.64614
        A_wo_11um_FIT_ICE =    0.00803
        B_wo_11um_FIT_ICE =    0.57305
        C_wo_11um_FIT_ICE =   -0.15597
        A_g_11um_FIT_ICE =    0.64634
        B_g_11um_FIT_ICE =    0.39846
        C_g_11um_FIT_ICE =   -0.11424

   case(10)  !-- ice clouds modeled as empirical model (b=0.10)
        A_BETA_11um_67um_FIT_ICE =  -1.85234
        B_BETA_11um_67um_FIT_ICE =   2.54585
        A_BETA_11um_85um_FIT_ICE =   2.20137
        B_BETA_11um_85um_FIT_ICE =  -1.21641
        A_BETA_11um_133um_FIT_ICE =  -2.41818
        B_BETA_11um_133um_FIT_ICE =   3.33027
        A_Re_Beta_FIT_ICE =  -77.35041
        B_Re_Beta_FIT_ICE =  202.52564
        C_Re_Beta_FIT_ICE =  -176.58311
        D_Re_Beta_FIT_ICE =  51.90699
        A_Qe_065um_FIT_ICE =  2.000
        B_Qe_065um_FIT_ICE =  0.000
        C_Qe_065um_FIT_ICE =  0.000
        A_Qe_11um_FIT_ICE =  -0.07506
        B_Qe_11um_FIT_ICE =  2.38798
        C_Qe_11um_FIT_ICE =  -0.69463
        A_wo_11um_FIT_ICE =  -0.06326
        B_wo_11um_FIT_ICE =  0.66222
        C_wo_11um_FIT_ICE =  -0.18387
        A_g_11um_FIT_ICE =  0.52725
        B_g_11um_FIT_ICE =  0.57902
        C_g_11um_FIT_ICE =  -0.18146

   case(11)  !-- ice clouds modeled as two-habit model (hexagonal column and ensemble of 20-elem distorted hexagonal-column aggregates) (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.81601
        B_BETA_11um_67um_FIT_ICE =    0.19836
        A_BETA_11um_85um_FIT_ICE =    1.25090
        B_BETA_11um_85um_FIT_ICE =   -0.23185
        A_BETA_11um_133um_FIT_ICE =   -0.00359
        B_BETA_11um_133um_FIT_ICE =    1.00462
        A_Re_Beta_FIT_ICE =  -29.55861
        B_Re_Beta_FIT_ICE =   66.00224
        C_Re_Beta_FIT_ICE =  -47.73748
        D_Re_Beta_FIT_ICE =   11.52144
        A_Qe_065um_FIT_ICE =    2.12514
        B_Qe_065um_FIT_ICE =   -0.10060
        C_Qe_065um_FIT_ICE =    0.02383
        A_Qe_11um_FIT_ICE =    0.26926
        B_Qe_11um_FIT_ICE =    1.60721
        C_Qe_11um_FIT_ICE =   -0.38442
        A_wo_11um_FIT_ICE =    0.17557
        B_wo_11um_FIT_ICE =    0.32917
        C_wo_11um_FIT_ICE =   -0.08284
        A_g_11um_FIT_ICE =    0.75992
        B_g_11um_FIT_ICE =    0.22363
        C_g_11um_FIT_ICE =   -0.05563

   case default  !-- ice clouds modeled as empirical model (b=0.10)
        A_BETA_11um_67um_FIT_ICE =  -1.85234
        B_BETA_11um_67um_FIT_ICE =   2.54585
        A_BETA_11um_85um_FIT_ICE =   2.20137
        B_BETA_11um_85um_FIT_ICE =  -1.21641
        A_BETA_11um_133um_FIT_ICE =  -2.41818
        B_BETA_11um_133um_FIT_ICE =   3.33027
        A_Re_Beta_FIT_ICE =  -77.35041
        B_Re_Beta_FIT_ICE =  202.52564
        C_Re_Beta_FIT_ICE =  -176.58311
        D_Re_Beta_FIT_ICE =  51.90699
        A_Qe_065um_FIT_ICE =  2.000
        B_Qe_065um_FIT_ICE =  0.000
        C_Qe_065um_FIT_ICE =  0.000
        A_Qe_11um_FIT_ICE =  -0.07506
        B_Qe_11um_FIT_ICE =  2.38798
        C_Qe_11um_FIT_ICE =  -0.69463
        A_wo_11um_FIT_ICE =  -0.06326
        B_wo_11um_FIT_ICE =  0.66222
        C_wo_11um_FIT_ICE =  -0.18387
        A_g_11um_FIT_ICE =  0.52725
        B_g_11um_FIT_ICE =  0.57902
        C_g_11um_FIT_ICE =  -0.18146

end select
