! Description: Include file that contains ice microphyscial model for AVHRR/NOAA19 sensor

select case(Habit_Idx)
   case(1)  !-- ice clouds modeled as droxtals (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.94574
        B_BETA_11um_67um_FIT_ICE =    0.07721
        A_BETA_11um_85um_FIT_ICE =    1.37883
        B_BETA_11um_85um_FIT_ICE =   -0.37944
        A_BETA_11um_133um_FIT_ICE =    0.00917
        B_BETA_11um_133um_FIT_ICE =    1.05483
        A_Re_Beta_FIT_ICE =  -14.76094
        B_Re_Beta_FIT_ICE =   32.84509
        C_Re_Beta_FIT_ICE =  -23.15064
        D_Re_Beta_FIT_ICE =    5.55170
        A_Qe_065um_FIT_ICE =    2.37303
        B_Qe_065um_FIT_ICE =   -0.34475
        C_Qe_065um_FIT_ICE =    0.08325
        A_Qe_11um_FIT_ICE =   -0.48999
        B_Qe_11um_FIT_ICE =    2.92676
        C_Qe_11um_FIT_ICE =   -0.83203
        A_wo_11um_FIT_ICE =   -0.08298
        B_wo_11um_FIT_ICE =    0.66063
        C_wo_11um_FIT_ICE =   -0.18104
        A_g_11um_FIT_ICE =    0.33630
        B_g_11um_FIT_ICE =    0.78387
        C_g_11um_FIT_ICE =   -0.23472

   case(2)  !-- ice clouds modeled as solid_bullet_rosettes (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.92173
        B_BETA_11um_67um_FIT_ICE =    0.09704
        A_BETA_11um_85um_FIT_ICE =    1.43197
        B_BETA_11um_85um_FIT_ICE =   -0.44237
        A_BETA_11um_133um_FIT_ICE =    0.23886
        B_BETA_11um_133um_FIT_ICE =    0.81598
        A_Re_Beta_FIT_ICE =   -5.59277
        B_Re_Beta_FIT_ICE =   12.77518
        C_Re_Beta_FIT_ICE =   -9.22859
        D_Re_Beta_FIT_ICE =    2.58537
        A_Qe_065um_FIT_ICE =    2.21393
        B_Qe_065um_FIT_ICE =   -0.22922
        C_Qe_065um_FIT_ICE =    0.06080
        A_Qe_11um_FIT_ICE =   -0.39695
        B_Qe_11um_FIT_ICE =    2.60419
        C_Qe_11um_FIT_ICE =   -0.70315
        A_wo_11um_FIT_ICE =   -0.01809
        B_wo_11um_FIT_ICE =    0.61474
        C_wo_11um_FIT_ICE =   -0.17036
        A_g_11um_FIT_ICE =    0.59873
        B_g_11um_FIT_ICE =    0.45479
        C_g_11um_FIT_ICE =   -0.13276

   case(3)  !-- ice clouds modeled as hollow_bullet_rosettes (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.98355
        B_BETA_11um_67um_FIT_ICE =    0.02396
        A_BETA_11um_85um_FIT_ICE =    1.43848
        B_BETA_11um_85um_FIT_ICE =   -0.47333
        A_BETA_11um_133um_FIT_ICE =   -0.00923
        B_BETA_11um_133um_FIT_ICE =    1.04791
        A_Re_Beta_FIT_ICE =   -7.97124
        B_Re_Beta_FIT_ICE =   18.64379
        C_Re_Beta_FIT_ICE =  -14.10797
        D_Re_Beta_FIT_ICE =    3.94284
        A_Qe_065um_FIT_ICE =    2.22570
        B_Qe_065um_FIT_ICE =   -0.21823
        C_Qe_065um_FIT_ICE =    0.05286
        A_Qe_11um_FIT_ICE =   -0.14259
        B_Qe_11um_FIT_ICE =    2.03034
        C_Qe_11um_FIT_ICE =   -0.49579
        A_wo_11um_FIT_ICE =    0.05464
        B_wo_11um_FIT_ICE =    0.49977
        C_wo_11um_FIT_ICE =   -0.13263
        A_g_11um_FIT_ICE =    0.72292
        B_g_11um_FIT_ICE =    0.30069
        C_g_11um_FIT_ICE =   -0.08553

   case(4)  !-- ice clouds modeled as solid_columns (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.95767
        B_BETA_11um_67um_FIT_ICE =    0.06010
        A_BETA_11um_85um_FIT_ICE =    1.38417
        B_BETA_11um_85um_FIT_ICE =   -0.38961
        A_BETA_11um_133um_FIT_ICE =   -0.01305
        B_BETA_11um_133um_FIT_ICE =    1.07322
        A_Re_Beta_FIT_ICE =  -11.99049
        B_Re_Beta_FIT_ICE =   26.81952
        C_Re_Beta_FIT_ICE =  -18.94549
        D_Re_Beta_FIT_ICE =    4.62599
        A_Qe_065um_FIT_ICE =    2.29425
        B_Qe_065um_FIT_ICE =   -0.27179
        C_Qe_065um_FIT_ICE =    0.06384
        A_Qe_11um_FIT_ICE =   -0.40019
        B_Qe_11um_FIT_ICE =    2.65894
        C_Qe_11um_FIT_ICE =   -0.73225
        A_wo_11um_FIT_ICE =   -0.06765
        B_wo_11um_FIT_ICE =    0.65718
        C_wo_11um_FIT_ICE =   -0.18013
        A_g_11um_FIT_ICE =    0.40639
        B_g_11um_FIT_ICE =    0.69717
        C_g_11um_FIT_ICE =   -0.20920

   case(5)  !-- ice clouds modeled as hollow_columns (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.95595
        B_BETA_11um_67um_FIT_ICE =    0.06167
        A_BETA_11um_85um_FIT_ICE =    1.37786
        B_BETA_11um_85um_FIT_ICE =   -0.38961
        A_BETA_11um_133um_FIT_ICE =   -0.05187
        B_BETA_11um_133um_FIT_ICE =    1.10223
        A_Re_Beta_FIT_ICE =  -11.55491
        B_Re_Beta_FIT_ICE =   25.29767
        C_Re_Beta_FIT_ICE =  -17.55596
        D_Re_Beta_FIT_ICE =    4.27792
        A_Qe_065um_FIT_ICE =    2.24902
        B_Qe_065um_FIT_ICE =   -0.23201
        C_Qe_065um_FIT_ICE =    0.05461
        A_Qe_11um_FIT_ICE =   -0.28559
        B_Qe_11um_FIT_ICE =    2.33203
        C_Qe_11um_FIT_ICE =   -0.61267
        A_wo_11um_FIT_ICE =   -0.02814
        B_wo_11um_FIT_ICE =    0.61295
        C_wo_11um_FIT_ICE =   -0.16858
        A_g_11um_FIT_ICE =    0.51336
        B_g_11um_FIT_ICE =    0.55480
        C_g_11um_FIT_ICE =   -0.16134

   case(6)  !-- ice clouds modeled as plates (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.92236
        B_BETA_11um_67um_FIT_ICE =    0.08481
        A_BETA_11um_85um_FIT_ICE =    1.29361
        B_BETA_11um_85um_FIT_ICE =   -0.33261
        A_BETA_11um_133um_FIT_ICE =   -0.05689
        B_BETA_11um_133um_FIT_ICE =    1.10292
        A_Re_Beta_FIT_ICE =  -10.61067
        B_Re_Beta_FIT_ICE =   23.95156
        C_Re_Beta_FIT_ICE =  -16.97925
        D_Re_Beta_FIT_ICE =    4.19689
        A_Qe_065um_FIT_ICE =    2.22636
        B_Qe_065um_FIT_ICE =   -0.23233
        C_Qe_065um_FIT_ICE =    0.05833
        A_Qe_11um_FIT_ICE =   -0.32305
        B_Qe_11um_FIT_ICE =    2.52783
        C_Qe_11um_FIT_ICE =   -0.68046
        A_wo_11um_FIT_ICE =   -0.07791
        B_wo_11um_FIT_ICE =    0.70587
        C_wo_11um_FIT_ICE =   -0.19886
        A_g_11um_FIT_ICE =    0.44993
        B_g_11um_FIT_ICE =    0.64537
        C_g_11um_FIT_ICE =   -0.19227

   case(7)  !-- ice clouds modeled as aggregate_columns (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    1.05090
        B_BETA_11um_67um_FIT_ICE =   -0.01637
        A_BETA_11um_85um_FIT_ICE =    1.50435
        B_BETA_11um_85um_FIT_ICE =   -0.48727
        A_BETA_11um_133um_FIT_ICE =    0.03881
        B_BETA_11um_133um_FIT_ICE =    1.01095
        A_Re_Beta_FIT_ICE =  -10.93929
        B_Re_Beta_FIT_ICE =   24.70588
        C_Re_Beta_FIT_ICE =  -17.89442
        D_Re_Beta_FIT_ICE =    4.61250
        A_Qe_065um_FIT_ICE =    2.24008
        B_Qe_065um_FIT_ICE =   -0.22154
        C_Qe_065um_FIT_ICE =    0.05269
        A_Qe_11um_FIT_ICE =   -0.25110
        B_Qe_11um_FIT_ICE =    2.30356
        C_Qe_11um_FIT_ICE =   -0.59547
        A_wo_11um_FIT_ICE =   -0.00289
        B_wo_11um_FIT_ICE =    0.58422
        C_wo_11um_FIT_ICE =   -0.16068
        A_g_11um_FIT_ICE =    0.63572
        B_g_11um_FIT_ICE =    0.39030
        C_g_11um_FIT_ICE =   -0.10809
        
   case(8)  !-- ice clouds modeled as small_aggregate_plates (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    1.03850
        B_BETA_11um_67um_FIT_ICE =   -0.02968
        A_BETA_11um_85um_FIT_ICE =    1.47964
        B_BETA_11um_85um_FIT_ICE =   -0.50255
        A_BETA_11um_133um_FIT_ICE =    0.04045
        B_BETA_11um_133um_FIT_ICE =    1.00847
        A_Re_Beta_FIT_ICE =  -10.62914
        B_Re_Beta_FIT_ICE =   24.51179
        C_Re_Beta_FIT_ICE =  -18.21316
        D_Re_Beta_FIT_ICE =    4.81030
        A_Qe_065um_FIT_ICE =    2.18201
        B_Qe_065um_FIT_ICE =   -0.15411
        C_Qe_065um_FIT_ICE =    0.03301
        A_Qe_11um_FIT_ICE =   -0.29832
        B_Qe_11um_FIT_ICE =    2.42478
        C_Qe_11um_FIT_ICE =   -0.63414
        A_wo_11um_FIT_ICE =    0.00570
        B_wo_11um_FIT_ICE =    0.55258
        C_wo_11um_FIT_ICE =   -0.14706
        A_g_11um_FIT_ICE =    0.62539
        B_g_11um_FIT_ICE =    0.42144
        C_g_11um_FIT_ICE =   -0.12152

   case(9)  !-- ice clouds modeled as large_aggregate_plates (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    1.05338
        B_BETA_11um_67um_FIT_ICE =   -0.06208
        A_BETA_11um_85um_FIT_ICE =    1.45329
        B_BETA_11um_85um_FIT_ICE =   -0.51005
        A_BETA_11um_133um_FIT_ICE =    0.06292
        B_BETA_11um_133um_FIT_ICE =    0.97838
        A_Re_Beta_FIT_ICE =  -19.27244
        B_Re_Beta_FIT_ICE =   46.09516
        C_Re_Beta_FIT_ICE =  -35.93042
        D_Re_Beta_FIT_ICE =    9.58879
        A_Qe_065um_FIT_ICE =    2.08905
        B_Qe_065um_FIT_ICE =   -0.05575
        C_Qe_065um_FIT_ICE =    0.00652
        A_Qe_11um_FIT_ICE =   -0.35818
        B_Qe_11um_FIT_ICE =    2.42999
        C_Qe_11um_FIT_ICE =   -0.61614
        A_wo_11um_FIT_ICE =    0.00841
        B_wo_11um_FIT_ICE =    0.55201
        C_wo_11um_FIT_ICE =   -0.14562
        A_g_11um_FIT_ICE =    0.64292
        B_g_11um_FIT_ICE =    0.40221
        C_g_11um_FIT_ICE =   -0.11573

   case(10)  !-- ice clouds modeled as empirical model (b=0.10)
        A_BETA_11um_67um_FIT_ICE =  -1.85234
        B_BETA_11um_67um_FIT_ICE =   2.54585
        A_BETA_11um_85um_FIT_ICE =   2.20137
        B_BETA_11um_85um_FIT_ICE =  -1.21641
        A_BETA_11um_133um_FIT_ICE =  -2.41818
        B_BETA_11um_133um_FIT_ICE =   3.33027
        A_Re_Beta_FIT_ICE =  -77.35041
        B_Re_Beta_FIT_ICE =  202.52564
        C_Re_Beta_FIT_ICE =  -176.58311
        D_Re_Beta_FIT_ICE =  51.90699
        A_Qe_065um_FIT_ICE =  2.000
        B_Qe_065um_FIT_ICE =  0.000
        C_Qe_065um_FIT_ICE =  0.000
        A_Qe_11um_FIT_ICE =  -0.07506
        B_Qe_11um_FIT_ICE =  2.38798
        C_Qe_11um_FIT_ICE =  -0.69463
        A_wo_11um_FIT_ICE =  -0.06326
        B_wo_11um_FIT_ICE =  0.66222
        C_wo_11um_FIT_ICE =  -0.18387
        A_g_11um_FIT_ICE =  0.52725
        B_g_11um_FIT_ICE =  0.57902
        C_g_11um_FIT_ICE =  -0.18146

   case(11)  !-- ice clouds modeled as two-habit model (hexagonal column and ensemble of 20-elem distorted hexagonal-column aggregates) (b=0.10)
        A_BETA_11um_67um_FIT_ICE =    0.86503
        B_BETA_11um_67um_FIT_ICE =    0.15603
        A_BETA_11um_85um_FIT_ICE =    1.43666
        B_BETA_11um_85um_FIT_ICE =   -0.42066
        A_BETA_11um_133um_FIT_ICE =   -0.24191
        B_BETA_11um_133um_FIT_ICE =    1.26075
        A_Re_Beta_FIT_ICE =  -71.90255
        B_Re_Beta_FIT_ICE =  173.15508
        C_Re_Beta_FIT_ICE = -137.30212
        D_Re_Beta_FIT_ICE =   36.29887
        A_Qe_065um_FIT_ICE =    2.13452
        B_Qe_065um_FIT_ICE =   -0.10949
        C_Qe_065um_FIT_ICE =    0.02599
        A_Qe_11um_FIT_ICE =    0.37203
        B_Qe_11um_FIT_ICE =    1.48345
        C_Qe_11um_FIT_ICE =   -0.34860
        A_wo_11um_FIT_ICE =    0.16357
        B_wo_11um_FIT_ICE =    0.32683
        C_wo_11um_FIT_ICE =   -0.07886
        A_g_11um_FIT_ICE =    0.75330
        B_g_11um_FIT_ICE =    0.22939
        C_g_11um_FIT_ICE =   -0.05713

   case default  !-- ice clouds modeled as empirical model (b=0.10)
        A_BETA_11um_67um_FIT_ICE =  -1.85234
        B_BETA_11um_67um_FIT_ICE =   2.54585
        A_BETA_11um_85um_FIT_ICE =   2.20137
        B_BETA_11um_85um_FIT_ICE =  -1.21641
        A_BETA_11um_133um_FIT_ICE =  -2.41818
        B_BETA_11um_133um_FIT_ICE =   3.33027
        A_Re_Beta_FIT_ICE =  -77.35041
        B_Re_Beta_FIT_ICE =  202.52564
        C_Re_Beta_FIT_ICE =  -176.58311
        D_Re_Beta_FIT_ICE =  51.90699
        A_Qe_065um_FIT_ICE =  2.000
        B_Qe_065um_FIT_ICE =  0.000
        C_Qe_065um_FIT_ICE =  0.000
        A_Qe_11um_FIT_ICE =  -0.07506
        B_Qe_11um_FIT_ICE =  2.38798
        C_Qe_11um_FIT_ICE =  -0.69463
        A_wo_11um_FIT_ICE =  -0.06326
        B_wo_11um_FIT_ICE =  0.66222
        C_wo_11um_FIT_ICE =  -0.18387
        A_g_11um_FIT_ICE =  0.52725
        B_g_11um_FIT_ICE =  0.57902
        C_g_11um_FIT_ICE =  -0.18146

end select
