!$Id:$
module ACHA_ICE_FRACTION_MODULE

 use ACHA_SERVICES_MOD, only : &
           real4, int1, int4, real8, dtor, &
           acha_output_struct,ACHA_SYMBOL_STRUCT

implicit none

private

public:: COMPUTE_ICE_FRACTION_FROM_TYPE
!public:: SETUP_ICE_FRACTION_LUT
!public:: COMPUTE_ICE_FRACTION_FROM_LUT

! Ice Fraction Algorithm LUT Variables
!real(kind=real4), private:: nbins_x, nbins_y, nbins_z
!real(kind=real4), private:: x_min, x_max, x_bin
!real(kind=real4), private:: y_min, y_max, y_bin
!real(kind=real4), private:: z_min, z_max, z_bin
!real(kind=real4), private:: nsfc
!real(kind=real4), private:: zsfc_min, zsfc_max, snow_class_min, snow_class_max

!type(ACHA_SYMBOL_STRUCT), private :: Symbol

contains

!----------------------------------------------------------------------
! Setup Ice Fraction Lookup Table
!----------------------------------------------------------------------


!----------------------------------------------------------------------
! Compute Ice Fraction from  Lookup Table
!----------------------------------------------------------------------


!----------------------------------------------------------------------
! Compute Ice Fraction from the Cloud Type
!----------------------------------------------------------------------
subroutine COMPUTE_ICE_FRACTION_FROM_TYPE(Cloud_Type, Symbol, Ice_Fraction, Ice_Fraction_Uncertainty)
   integer(kind=int1), intent(in):: Cloud_Type
   real, intent(out):: Ice_Fraction, Ice_Fraction_Uncertainty
   type(ACHA_SYMBOL_STRUCT), intent(in) :: Symbol

   if (Cloud_Type == Symbol%FOG_TYPE) then
         Ice_Fraction = 0.0
         Ice_Fraction_Uncertainty = 0.2
   elseif (Cloud_Type == Symbol%WATER_TYPE) then
         Ice_Fraction = 0.0
         Ice_Fraction_Uncertainty = 0.2
   elseif (Cloud_Type == Symbol%SUPERCOOLED_TYPE) then
         Ice_Fraction = 0.0
         Ice_Fraction_Uncertainty = 0.2
   elseif (Cloud_Type == Symbol%MIXED_TYPE) then
         Ice_Fraction = 0.0
         Ice_Fraction_Uncertainty = 0.2
   elseif (Cloud_Type == Symbol%OPAQUE_ICE_TYPE) then
         Ice_Fraction = 1.0
         Ice_Fraction_Uncertainty = 0.1
   elseif (Cloud_Type == Symbol%CIRRUS_TYPE) then
         Ice_Fraction = 1.0
         Ice_Fraction_Uncertainty = 0.4
   elseif (Cloud_Type == Symbol%OVERLAP_TYPE) then
         Ice_Fraction = 1.0
         Ice_Fraction_Uncertainty = 0.2
   elseif (Cloud_Type == Symbol%OVERSHOOTING_TYPE) then
         Ice_Fraction = 1.0
         Ice_Fraction_Uncertainty = 0.1
   else
         Ice_Fraction = 0.0
         Ice_Fraction_Uncertainty = 0.2
   endif

!  Ice_Fraction = 0.5
!  Ice_Fraction_Uncertainty = 0.5

end subroutine COMPUTE_ICE_FRACTION_FROM_TYPE

end module ACHA_ICE_FRACTION_MODULE
