! $Id: muri_array_loop_sub.f90 2424 2017-12-18 14:30:36Z awalther $
!
!

subroutine muri_array_loop (input, output )
   
   use muri_interface_mod,only: &
      muri_in_array_type &
      , muri_out_array_type
   
   use muri_retrieval_mod
   
   use muri_definitions_mod, only: &
      muri_input_type  &
      , muri_output_type
      
   use muri_atmospheric_corr_mod, only: &
       muri_transmission_default
   
   implicit none
   
   type ( muri_in_array_type) , intent(in):: input
   type ( muri_out_array_type) :: output
   type ( muri_input_type) :: inp_pixel
   type ( muri_output_type) :: out_pixel
   integer :: i,j,k
   logical :: print_info
   real :: trans_re(6)
   
   print_info = .false.
    
   
   call output % reset
   inp_pixel % path = trim('/apollo/cloud/Ancil_Data/clavrx_ancil_data/static/luts/muri/')
     
   do i = 1, input % dim(1)
  
      do j = 1, input % dim(2)
       
         if ( .not. input % do_it(i,j)) cycle
        
         inp_pixel % sat = input % sat(i,j)
         inp_pixel % sol = input % sol(i,j)
         inp_pixel % azi = input % azi(i,j)
         inp_pixel % ws = 2.0
         inp_pixel % path = input % path
         
         ! atmospheric correction
         
         trans_re = muri_transmission_default (inp_pixel % sol,inp_pixel % sat)
         do k=1,6
            inp_pixel % rfl(k) = input % ref(k,i,j) * trans_re(k)
         end do
        ! call inp_pixel % info
         call muri_algorithm( inp_pixel, out_pixel )
      
       !  do k=1, 6
           ! print*,out_pixel % aot
            !output % aot_channel(k,i,j) = out_pixel % aot_channel(k)
       !  end do 
       
         output % aot(i,j) = out_pixel % aot
         output % cm_mode(i,j) = out_pixel % cm_mode
         output % fm_mode(i,j) = out_pixel % fm_mode
         output % fmf ( i,j) = out_pixel % fmf
         output % sediment_class ( i,j) = out_pixel % sediment_class
         if ( print_info) then
            print*
            print*,i,j
            print*,'refl: ',inp_pixel % rfl
            print*,'cm fm: ',out_pixel % cm_mode, out_pixel % fm_mode, out_pixel %  fmf
            print*,'aod: ',out_pixel % aot
            print*  
         end if
        
      end do
   end do   
   

end subroutine muri_array_loop
